// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlStackList")]
    pub struct StackList(Object<ffi::DzlStackList, ffi::DzlStackListClass>) @extends gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_stack_list_get_type(),
    }
}

impl StackList {
    pub const NONE: Option<&'static StackList> = None;

    #[doc(alias = "dzl_stack_list_new")]
    pub fn new() -> StackList {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_stack_list_new()).unsafe_cast() }
    }
}

impl Default for StackList {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::StackList>> Sealed for T {}
}

pub trait StackListExt: IsA<StackList> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_stack_list_clear")]
    fn clear(&self) {
        unsafe {
            ffi::dzl_stack_list_clear(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_stack_list_get_depth")]
    #[doc(alias = "get_depth")]
    fn depth(&self) -> u32 {
        unsafe { ffi::dzl_stack_list_get_depth(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "dzl_stack_list_get_model")]
    #[doc(alias = "get_model")]
    fn model(&self) -> Option<gio::ListModel> {
        unsafe {
            from_glib_none(ffi::dzl_stack_list_get_model(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_stack_list_pop")]
    fn pop(&self) {
        unsafe {
            ffi::dzl_stack_list_pop(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_stack_list_push")]
    fn push<P: Fn(&glib::Object) -> gtk::Widget + 'static>(
        &self,
        header: &impl IsA<gtk::Widget>,
        model: &impl IsA<gio::ListModel>,
        create_widget_func: P,
    ) {
        let create_widget_func_data: Box_<P> = Box_::new(create_widget_func);
        unsafe extern "C" fn create_widget_func_func<
            P: Fn(&glib::Object) -> gtk::Widget + 'static,
        >(
            item: *mut glib::gobject_ffi::GObject,
            user_data: glib::ffi::gpointer,
        ) -> *mut gtk::ffi::GtkWidget {
            let item = from_glib_borrow(item);
            let callback: &P = &*(user_data as *mut _);
            (*callback)(&item).to_glib_full()
        }
        let create_widget_func = Some(create_widget_func_func::<P> as _);
        unsafe extern "C" fn user_data_free_func_func<
            P: Fn(&glib::Object) -> gtk::Widget + 'static,
        >(
            data: glib::ffi::gpointer,
        ) {
            let _callback: Box_<P> = Box_::from_raw(data as *mut _);
        }
        let destroy_call5 = Some(user_data_free_func_func::<P> as _);
        let super_callback0: Box_<P> = create_widget_func_data;
        unsafe {
            ffi::dzl_stack_list_push(
                self.as_ref().to_glib_none().0,
                header.as_ref().to_glib_none().0,
                model.as_ref().to_glib_none().0,
                create_widget_func,
                Box_::into_raw(super_callback0) as *mut _,
                destroy_call5,
            );
        }
    }

    #[doc(alias = "header-activated")]
    fn connect_header_activated<F: Fn(&Self, &gtk::ListBoxRow) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn header_activated_trampoline<
            P: IsA<StackList>,
            F: Fn(&P, &gtk::ListBoxRow) + 'static,
        >(
            this: *mut ffi::DzlStackList,
            object: *mut gtk::ffi::GtkListBoxRow,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                StackList::from_glib_borrow(this).unsafe_cast_ref(),
                &from_glib_borrow(object),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"header-activated\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    header_activated_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "row-activated")]
    fn connect_row_activated<F: Fn(&Self, &gtk::ListBoxRow) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn row_activated_trampoline<
            P: IsA<StackList>,
            F: Fn(&P, &gtk::ListBoxRow) + 'static,
        >(
            this: *mut ffi::DzlStackList,
            object: *mut gtk::ffi::GtkListBoxRow,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                StackList::from_glib_borrow(this).unsafe_cast_ref(),
                &from_glib_borrow(object),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"row-activated\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    row_activated_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "model")]
    fn connect_model_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_model_trampoline<P: IsA<StackList>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlStackList,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(StackList::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::model\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_model_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<StackList>> StackListExt for O {}

impl fmt::Display for StackList {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("StackList")
    }
}
